<!DOCTYPE html>
<html>
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <!-- font -->
    <link
      rel="stylesheet"
      href="https://fonts.googleapis.com/css?family=Lato"
    />
    <link
      rel="stylesheet"
      href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css"
    />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="css/stylemin.css" />
    <link rel="stylesheet" href="css/color.css" />
    <title>Pizza 365 v1.0</title>
  </head>

  <body>
    <!-- Menu -->
    <div class="container-fluid">
      <div class="row">
        <div class="col-sm-12">
          <nav class="navbar fixed-top navbar-expand-lg navbar-light bg-light">
            <button
              class="navbar-toggler"
              type="button"
              data-toggle="collapse"
              data-target="#navbarNav"
              aria-controls="navbarNav"
              aria-expanded="false"
              aria-label="Toggle navigation"
            >
              <span class="navbar-toggler-icon"></span>
            </button>
            <div class="collapse navbar-collapse" id="navbarNav">
              <ul class="navbar-nav nav-fill w-100">
                <li class="nav-item active">
                  <a class="nav-link" href="#">HOME</a>
                </li>
                <li class="nav-item">
                  <a class="nav-link" href="#combo">SIZE COMBOS</a>
                </li>
                <li class="nav-item">
                  <a class="nav-link" href="#type">PIZZA TYPES</a>
                </li>
                <li class="nav-item">
                  <a class="nav-link" href="#contact">FORM CONTACT</a>
                </li>
              </ul>
            </div>
          </nav>
        </div>
      </div>
    </div>

    <!-- Content -->
    <div class="container" style="padding: 70px 0px 50px 0px">
      <div class="row">
        <div class="col-sm-12">
          <div class="row">
            <!-- Title row home -->
            <div class="col-sm-12">
              <h1><b class="text-main">Pizza 365</b></h1>
              <p style="font-style: italic" class="text-second">
                Truly italian!
              </p>
            </div>

            <!-- Slide row home -->
            <div class="col-sm-12">
              <div
                id="carouselExampleIndicators"
                class="carousel slide"
                data-ride="carousel"
              >
                <ol class="carousel-indicators">
                  <li
                    data-target="#carouselExampleIndicators"
                    data-slide-to="0"
                    class="active"
                  ></li>
                  <li
                    data-target="#carouselExampleIndicators"
                    data-slide-to="1"
                  ></li>
                  <li
                    data-target="#carouselExampleIndicators"
                    data-slide-to="2"
                  ></li>
                  <li
                    data-target="#carouselExampleIndicators"
                    data-slide-to="3"
                  ></li>
                  <li
                    data-target="#carouselExampleIndicators"
                    data-slide-to="4"
                  ></li>
                  <li
                    data-target="#carouselExampleIndicators"
                    data-slide-to="5"
                  ></li>
                  <li
                    data-target="#carouselExampleIndicators"
                    data-slide-to="6"
                  ></li>
                </ol>
                <div class="carousel-inner">
                  <div class="carousel-item active">
                    <img
                      class="d-block w-100"
                      src="images/anh_mon_1.jpg"
                      alt="First slide"
                    />
                  </div>
                  <div class="carousel-item">
                    <img
                      class="d-block w-100"
                      src="images/anh_mon_2.jpg"
                      alt="Second slide"
                    />
                  </div>
                  <div class="carousel-item">
                    <img
                      class="d-block w-100"
                      src="images/anh_mon_3.jpg"
                      alt="Third slide"
                    />
                  </div>
                  <div class="carousel-item">
                    <img
                      class="d-block w-100"
                      src="images/anh_mon_4.jpg"
                      alt="Fourth slide"
                    />
                  </div>
                  <div class="carousel-item">
                    <img
                      class="d-block w-100"
                      src="images/anh_mon_5.jpg"
                      alt="Fifth slide"
                    />
                  </div>
                  <div class="carousel-item">
                    <img
                      class="d-block w-100"
                      src="images/anh_mon_6.jpg"
                      alt="Fifth slide"
                    />
                  </div>
                  <div class="carousel-item">
                    <img
                      class="d-block w-100"
                      src="images/anh_mon_7.jpg"
                      alt="Fifth slide"
                    />
                  </div>
                </div>
                <a
                  class="carousel-control-prev"
                  href="#carouselExampleIndicators"
                  role="button"
                  data-slide="prev"
                >
                  <span
                    class="carousel-control-prev-icon"
                    aria-hidden="true"
                  ></span>
                  <span class="sr-only">Previous</span>
                </a>
                <a
                  class="carousel-control-next"
                  href="#carouselExampleIndicators"
                  role="button"
                  data-slide="next"
                >
                  <span
                    class="carousel-control-next-icon"
                    aria-hidden="true"
                  ></span>
                  <span class="sr-only">Next</span>
                </a>
              </div>
            </div>

            <!-- Title ưu điểm của Quán -->
            <div class="col-sm-12 text-center p-4 mt-4">
              <h2><b class="p-2 border-bottom">Tại sao lại Pizza 365</b></h2>
            </div>

            <!-- Content ưu điểm của Quán -->
            <div class="col-sm-12">
              <div class="row">
                <div class="col-sm-3 p-3 bg-brand-01 text-white border">
                  <h3 class="p-2">Không ngừng cải tiến</h3>
                  <p class="p-2">
                    Cải tiến sản phẩm, chất lượng và trải nghiệm khách hàng luôn
                    là yếu tố tiên quyết trong chiến lược kinh doanh của chúng
                    tôi nhằm thúc đẩy tăng trưởng và trở thành thương hiệu pizza
                    hàng đầu.
                  </p>
                </div>
                <div class="col-sm-3 p-3 bg-brand-02 text-white border">
                  <h3 class="p-2">Trải nghiệm dễ dàng</h3>
                  <p class="p-2">
                    Chúng tôi đơn giản hướng đến việc trở thành thương hiệu của
                    mọi nhà, mọi lúc, mọi nơi.
                  </p>
                </div>
                <div class="col-sm-3 p-3 bg-brand-03 text-white border">
                  <h3 class="p-2">Hướng đến sự vượt trội</h3>
                  <p class="p-2">
                    "Vượt trội" không chỉ là một khái niệm lớn. Thay vào đó, giá
                    trị này là cốt lõi trong mỗi con người của chúng tôi, trong
                    mỗi công việc mà họ làm.
                  </p>
                </div>
                <div class="col-sm-3 p-3 bg-brand-04 text-white border">
                  <h3 class="p-2">Thể hiện đam mê</h3>
                  <p class="p-2">
                    Chúng tôi sẵn lòng hỗ trợ vô điều kiện và linh động điều
                    chỉnh tùy theo thử thách để tìm ra giải pháp.
                  </p>
                </div>
              </div>
            </div>
          </div>

          <div id="combo" class="row">
            <!-- Title Size Combos -->
            <div class="col-sm-12 text-center p-4 mt-4">
              <h2><b class="p-1 border-bottom">Menu combo Pizza 365</b></h2>
              <p><span class="p-2">Hãy chọn combo phù hợp với bạn</span></p>
            </div>
            <!-- Content các Size Combos -->
            <div class="col-sm-12">
              <div class="row combo-pizza">
                <div class="col-sm-4">
                  <div class="card">
                    <div
                      class="card-header bg-main-brand text-white text-center"
                    >
                      <h3>S ( Small size)</h3>
                    </div>
                    <div class="card-body text-center">
                      <ul class="list-group list-group-flush">
                        <li class="list-group-item">
                          Đường kính <b> 20 cm</b>
                        </li>
                        <li class="list-group-item">Sườn nướng <b>2</b></li>
                        <li class="list-group-item">Salad <b>200 gr</b></li>
                        <li class="list-group-item">Nước ngọt <b>2</b></li>
                        <li class="list-group-item">
                          <h1>VND <b>150,000</b></h1>
                        </li>
                      </ul>
                    </div>
                    <div class="card-footer text-center">
                      <button
                        class="btn-green"
                        id="btn-size-small"
                        data-is-selected="N"
                        onclick="onBtnSmallSizeClick()"
                      >
                        Chọn
                      </button>
                    </div>
                  </div>
                </div>
                <div class="col-sm-4">
                  <div class="card">
                    <div
                      class="card-header bg-main-brand text-white text-center"
                    >
                      <h3>M (Medium size)</h3>
                    </div>
                    <div class="card-body text-center">
                      <ul class="list-group list-group-flush">
                        <li class="list-group-item">
                          Đường kính <b> 25 cm</b>
                        </li>
                        <li class="list-group-item">Sườn nướng <b>4</b></li>
                        <li class="list-group-item">Salad <b> 300 gr</b></li>
                        <li class="list-group-item">Nước ngọt <b>3</b></li>
                        <li class="list-group-item">
                          <h1>VND <b>200,000</b></h1>
                        </li>
                      </ul>
                    </div>
                    <div class="card-footer text-center">
                      <button
                        class="btn-green"
                        id="btn-size-medium"
                        data-is-selected="N"
                        onclick="onBtnMediumSizeClick()"
                      >
                        Chọn
                      </button>
                    </div>
                  </div>
                </div>
                <div class="col-sm-4">
                  <div class="card">
                    <div
                      class="card-header bg-main-brand text-white text-center"
                    >
                      <h3>L ( Large size )</h3>
                    </div>
                    <div class="card-body text-center">
                      <ul class="list-group list-group-flush">
                        <li class="list-group-item">
                          Đường kính <b> 30 cm</b>
                        </li>
                        <li class="list-group-item">Sườn nướng <b>8</b></li>
                        <li class="list-group-item">Salad <b> 500 gr</b></li>
                        <li class="list-group-item">Nước ngọt <b>4</b></li>
                        <li class="list-group-item">
                          <h1>VND <b>250,000</b></h1>
                        </li>
                      </ul>
                    </div>
                    <div class="card-footer text-center">
                      <button
                        class="btn-green"
                        id="btn-size-large"
                        data-is-selected="N"
                        onclick="onBtnLargeSizeClick()"
                      >
                        Chọn
                      </button>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>

          <div id="type" class="row">
            <!-- Title Pizza Type -->
            <div class="col-sm-12 text-center p-4 mt-4">
              <h2><b class="p-2 border-bottom">Chọn loại pizza</b></h2>
            </div>

            <!-- Content Pizza Type -->
            <div class="col-sm-12">
              <div class="row pizza-type">
                <div class="col-sm-4">
                  <div class="card w-100" style="width: 18rem">
                    <img
                      src="images/pizza_type_hawai.jpg"
                      class="card-img-top"
                    />
                    <div class="card-body">
                      <h3>Pizza Hawai</h3>
                      <p>Món ăn thanh đạm</p>
                      <p>
                        Hãy thưởng thức món ăn với phong cách Alo Ha đến từ
                        Hawai.
                      </p>
                      <p>
                        <button
                          class="btn-green"
                          id="btn-type-hawai"
                          data-is-selected="N"
                          onclick="onBtnPizzaHawaiClick()"
                        >
                          Chọn
                        </button>
                      </p>
                    </div>
                  </div>
                </div>
                <div class="col-sm-4">
                  <div class="card w-100" style="width: 18rem">
                    <img
                      src="images/pizza_type_hai_san.jpg"
                      class="card-img-top"
                    />
                    <div class="card-body">
                      <h3>Pizza Hải sản</h3>
                      <p>Món ăn đến từ biển</p>
                      <p>
                        Bạn đã thử pizza được chế biến từ nguyên liệu hải sản
                        chưa ?
                      </p>
                      <p>
                        <button
                          class="btn-green"
                          id="btn-type-hai-san"
                          data-is-selected="N"
                          onclick="onBtnPizzaHaiSanClick()"
                        >
                          Chọn
                        </button>
                      </p>
                    </div>
                  </div>
                </div>
                <div class="col-sm-4">
                  <div class="card w-100" style="width: 18rem">
                    <img
                      src="images/pizza_type_thit_nuong.jpg"
                      class="card-img-top"
                    />
                    <div class="card-body">
                      <h3>Pizza Bacon</h3>
                      <p>Món ăn đăc biệt</p>
                      <p>
                        Được chế biến từ thịt bacon. Mang đến hương vị mới lạ.
                      </p>
                      <p>
                        <button
                          class="btn-green"
                          id="btn-type-bacon"
                          data-is-selected="N"
                          onclick="onBtnPizzaBaconClick()"
                        >
                          Chọn
                        </button>
                      </p>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>

          <div id="type" class="row">
            <!-- Title drinks  -->
            <div class="col-sm-12 text-center p-4 mt-4">
              <h2><b class="p-2 border-bottom">Đồ uống</b></h2>
            </div>
            <!-- Content drink -->
            <div class="col-sm-12">
              <select id="select-drinks" class="form-control">
                <option value="0">-- Chọn đồ uống --</option>
              </select>
            </div>
          </div>

          <div id="contact" class="row">
            <!-- Title Form Contact Us -->
            <div class="col-sm-12 text-center p-4 mt-4">
              <h2><b class="p-2 border-bottom">Thông tin đơn hàng</b></h2>
            </div>

            <!-- Content Form Contact Us -->
            <div class="col-sm-12 p-2 jumbotron">
              <div class="row">
                <div class="col-sm-12">
                  <div class="form-group">
                    <label for="input-name">Họ và tên</label>
                    <input
                      type="text"
                      class="form-control"
                      id="input-name"
                      placeholder="Họ và tên"
                    />
                  </div>
                  <div class="form-group">
                    <label for="email">Email</label>
                    <input
                      type="text"
                      class="form-control"
                      id="input-email"
                      placeholder="Email"
                    />
                  </div>
                  <div class="form-group">
                    <label for="input-phone">Điện thoại</label>
                    <input
                      type="text"
                      class="form-control"
                      id="input-phone"
                      placeholder="Điện thoại"
                    />
                  </div>
                  <div class="form-group">
                    <label for="input-address">Địa chỉ</label>
                    <input
                      type="text"
                      class="form-control"
                      id="input-address"
                      placeholder="Địa chỉ"
                    />
                  </div>
                  <div class="form-group">
                    <label for="message">Lời nhắn</label>
                    <input
                      type="text"
                      class="form-control"
                      id="input-message"
                      placeholder="Lời nhắn"
                    />
                  </div>
                  <div class="form-group">
                    <label for="message">Mã giảm giá (Voucher ID)</label>
                    <input
                      type="text"
                      class="form-control"
                      id="input-voucher"
                      placeholder="Mã voucher"
                    />
                  </div>
                  <button
                    type="button"
                    class="btn-green"
                    onclick="onBtnKiemTraClick()"
                  >
                    Kiểm tra đơn
                  </button>
                </div>
              </div>
            </div>
            <!-- vùng hiển thị thông tin đơn hàng(order) -->
            <div
              id="div-container-order"
              class="container bg-info p-2 jumbotron"
              style="display: none"
            >
              <div id="div-order-infor" class="text-white p-3">
                thông tin đơn hàng vào đây
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>

    <!-- Footer -->
    <div class="container-fluid bg-light p-3">
      <div class="row text-center">
        <div class="col-sm-12">
          <h4 class="m-2">Footer</h4>
          <a href="#" class="btn bg-main-brand text-white m-3"
            ><i class="fa fa-arrow-up mr-2"></i>To the top</a
          >
          <div class="m-2">
            <i class="fa fa-facebook-official text-main"></i>
            <i class="fa fa-instagram text-main"></i>
            <i class="fa fa-snapchat text-main"></i>
            <i class="fa fa-pinterest-p text-main"></i>
            <i class="fa fa-twitter text-main"></i>
            <i class="fa fa-linkedin text-main"></i>
          </div>
        </div>
      </div>
    </div>
  </body>
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200; // GET & PUT success
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gREQUEST_CREATE_SUCCESS = 201;
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365";
    //loại combo
    const gSMALL_SIZE = "SMALL";
    const gMEDIUM_SIZE = "MEDIUM";
    const gLARGE_SIZE = "LARGE";
    //loại pizza
    const gHAWAI_PIZZA = "Hawai";
    const gHAI_SAN_PIZZA = "Hải sản";
    const gBACON_PIZZA = "Bacon";
    //biến toàn cục
    var gSelectedCombo = null;
    var gSelectedPizza = "";
    var gOrder = null;
    // Mảng danh sách các mã giảm giá
    var gDiscountVouchers = [
      { voucherID: "10345", percentDiscount: 20 }, // mã giảm giá là 10345, phần trăm giảm giá 20%
      { voucherID: "11346", percentDiscount: 10 },
      { voucherID: "20445", percentDiscount: 5 },
      { voucherID: "21457", percentDiscount: 30 },
      { voucherID: "32154", percentDiscount: 20 },
      { voucherID: "30546", percentDiscount: 25 },
      { voucherID: "41351", percentDiscount: 15 },
      { voucherID: "53360", percentDiscount: 5 },
      { voucherID: "65343", percentDiscount: 30 },
      { voucherID: "78328", percentDiscount: 40 },
    ];
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    $(document).ready(function () {
      onPageLoading();
    });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //hàm xử lý khi load page
    function onPageLoading() {
      "use strict";
      //load đồ uống
      getAllDrinks();
      //load combo pizza
      getComboPizza();
      //load combo pizza
      getPizza();
    }
    //hàm xử lý khi nút kiểm tra dữ liệu được nhấn
    function onBtnKiemTraClick() {
      "use strict";
      //tạo đối tượng order(đơn hàng)
      var vOrderObject = {
        menuDuocChon: null,
        loaiNuocUong: "",
        loaiPizza: "",
        hoVaTen: "",
        email: "",
        dienThoai: "",
        diaChi: "",
        loiNhan: "",
        voucher: "",
        phanTramGiamGia: 0,
        priceAnnualVND: function () {
          // nếu có mã giảm giá thì áp dụng
          return this.phanTramGiamGia != 0
            ? this.menuDuocChon.priceVND * this.phanTramGiamGia * 0.01
            : 0;
        },
      };
      //bước 1 - thu thập dữ liệu
      getDataFormInput(vOrderObject);
      //bước 2 - kiểm tra dữ liệu
      var vCheck = validateData(vOrderObject);
      //bước 3 - hiển thị dữ liệu
      if (vCheck) {
        //lấy giá trị phần trăm giảm giá dựa vào mã giảm giá
        if (vOrderObject.voucher != "")
          vOrderObject.phanTramGiamGia = getDiscountByVoucherID(
            vOrderObject.voucher
          );
        //gán order vào biến toàn cục để lấy thông tin
        gOrder = vOrderObject;
        //truy xuất vùng hiện thị thông tin
        var vThongBaoDiv = $("#div-container-order");
        var vThongBaoArea = $("#div-order-infor");
        //hiển thị vùng ẩn
        vThongBaoDiv.css("display", "block");
        //hiển thị thông tin đơn hàng
        vThongBaoArea.html(`Họ và tên: ${vOrderObject.hoVaTen}<br/>
                                       Email: ${vOrderObject.email}<br/>
                                       Số điện thoại: ${
                                         vOrderObject.dienThoai
                                       }<br/>
                                       Địa chỉ: ${vOrderObject.diaChi}<br/>
                                       Lời nhắn: ${vOrderObject.loiNhan}<br/>
                                       ------------------------------<br/>
                                       Kíck cỡ: ${
                                         vOrderObject.menuDuocChon.menuName
                                       }<br/>
                                       Đường kính: ${
                                         vOrderObject.menuDuocChon.duongKinhCM
                                       }cm<br/>
                                       Sườn nướng: ${
                                         vOrderObject.menuDuocChon.suonNuong
                                       }<br/>
                                       Salad: ${
                                         vOrderObject.menuDuocChon.saladGr
                                       }gr<br/>
                                       Nước ngọt: ${
                                         vOrderObject.menuDuocChon.drink
                                       }<br/>
                                        Loại đồ uống: ${
                                          vOrderObject.loaiNuocUong
                                        }<br/>
                                       ------------------------------<br/>
                                       Loại Pizza: ${
                                         vOrderObject.loaiPizza
                                       }<br/>
                                       Mã voucher: ${vOrderObject.voucher}<br/>
                                       Giá: ${
                                         vOrderObject.menuDuocChon.priceVND
                                       } VND<br/>
                                       Discount: ${
                                         vOrderObject.phanTramGiamGia
                                       }%<br/>
                                       Phải thanh toán: ${
                                         vOrderObject.menuDuocChon.priceVND -
                                         vOrderObject.priceAnnualVND()
                                       }<br/>
                                       <div class="p-2">
                                        <button class="btn-yellow" onclick="onBtnSendClick()">
                                          Gửi đơn
                                        </button>
                                       </div>`);
      }
    }
    //hàm xử lý khi nút gửi được nhấn
    function onBtnSendClick() {
      "use strict";
      //create request
      var vRequest = new XMLHttpRequest();
      //send create order
      createOrder(vRequest, gOrder);
      //get response
      vRequest.onreadystatechange = function () {
        if (
          this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK &&
          this.status == gREQUEST_CREATE_SUCCESS
        ) {
          hanlderCreateResponse(vRequest);
        }
      };
    }
    //hàm thực thi khi nút small size được nhấn
    function onBtnSmallSizeClick() {
      "use strict";
      //thay đổi màu nút khi nhấn + đổi thuộc tính data-is-selected = Y
      changeButtonColor(gSMALL_SIZE);
      //tạo một đối tượng gói dịch vụ, được tham số hóa
      gSelectedCombo = getSizeComboObject("S", "20", 2, "200", 2, 150000);
      // gọi method hiển thị thông tin
      gSelectedCombo.displayInConsoleLog();
    }
    //hàm thực thi khi nút medium size được nhấn
    function onBtnMediumSizeClick() {
      "use strict";
      //thay đổi màu nút khi nhấn + đổi thuộc tính data-is-selected = Y
      changeButtonColor(gMEDIUM_SIZE);
      //tạo một đối tượng gói dịch vụ, được tham số hóa
      gSelectedCombo = getSizeComboObject("M", "25", 4, "300", 3, 200000);
      // gọi method hiển thị thông tin
      gSelectedCombo.displayInConsoleLog();
    }
    //hàm thực thi khi nút large size được nhấn
    function onBtnLargeSizeClick() {
      "use strict";
      //thay đổi màu nút khi nhấn + đổi thuộc tính data-is-selected = Y
      changeButtonColor(gLARGE_SIZE);
      //tạo một đối tượng gói dịch vụ, được tham số hóa
      gSelectedCombo = getSizeComboObject("L", "30", 8, "500", 4, 250000);
      // gọi method hiển thị thông tin
      gSelectedCombo.displayInConsoleLog();
    }
    //hàm thực thi khi nút pizza hawai được nhấn
    function onBtnPizzaHawaiClick() {
      "use strict";
      //thay đổi màu nút khi nhấn + đổi thuộc tính data-is-selected = Y
      changeButtonColor(gHAWAI_PIZZA);
      gSelectedPizza = gHAWAI_PIZZA;
      //ghi ra console log
      console.log("Bạn đã chọn loại pizza:", gHAWAI_PIZZA);
      console.log("============================");
    }
    //hàm thực thi khi nút pizza hải sản được nhấn
    function onBtnPizzaHaiSanClick() {
      "use strict";
      //thay đổi màu nút khi nhấn + đổi thuộc tính data-is-selected = Y
      changeButtonColor(gHAI_SAN_PIZZA);
      gSelectedPizza = gHAI_SAN_PIZZA;
      //ghi ra console log
      console.log("Bạn đã chọn loại pizza:", gHAI_SAN_PIZZA);
      console.log("============================");
    }
    //hàm thực thi khi nút pizza bacon được nhấn
    function onBtnPizzaBaconClick() {
      "use strict";
      //thay đổi màu nút khi nhấn + đổi thuộc tính data-is-selected = Y
      changeButtonColor(gBACON_PIZZA);
      gSelectedPizza = gBACON_PIZZA;
      //ghi ra console log
      console.log("Bạn đã chọn loại pizza:", gBACON_PIZZA);
      console.log("============================");
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //hàm load load pizza
    function loadPizza(paramCombo) {
      "use strict";
      var vRowPizza = $(".pizza-type");
      var vSrcImage = "";
      vRowPizza.html(""); //empty element
      //loop
      paramCombo.forEach((item) => {
        //set image src
        if (item.loaiPizza == "seafood") {
          vSrcImage = "images/pizza_type_hai_san.jpg";
        } else if (item.loaiPizza == "bacon") {
          vSrcImage = "images/pizza_type_thit_nuong.jpg";
        } else if (item.loaiPizza == "hawai") {
          vSrcImage = "images/pizza_type_hawai.jpg";
        }
        //card
        var vCard = $("<div>", {
          class: "col-sm-4",
        })
          .append("<div class='card w-100' style='width: 18rem'>")
          .appendTo(vRowPizza);
        //card image
        $("<img>", {
          src: vSrcImage,
          class: "card-img-top",
        }).appendTo(vCard);
        //card body
        var vCardBody = $("<div>", {
          class: "card-body",
        }).appendTo(vCard);
        $("<h3>", {
          html: `Pizza ${item.name}`,
        }).appendTo(vCardBody);
        $("<p>", {
          html: item.note,
        })
          .css("text-transform", "lowercase")
          .appendTo(vCardBody);
        $("<p>", {
          html: item.description,
        }).appendTo(vCardBody);
        $("<button>", {
          html: "Chọn",
          class: "btn-green",
          id: `btn-type-${item.loaiPizza}`,
        })
          .data("is-selected", "N")
          .appendTo(vCardBody);
      });
      //gán sự kiện cho nút chọn pizza
      $("#btn-type-seafood").on("click", function () {
        onBtnPizzaHaiSanClick();
      });
      $("#btn-type-hawai").on("click", function () {
        onBtnPizzaHawaiClick();
      });
      $("#btn-type-bacon").on("click", function () {
        onBtnPizzaBaconClick();
      });
    }

    //hàm load load combo pizza
    function loadComboPizza(paramCombo) {
      "use strict";
      var vRowComboPizza = $(".combo-pizza");
      vRowComboPizza.html("");
      var sizeType = "";
      //loop
      paramCombo.forEach((item) => {
        //set size type
        if (item.kichCo == "S") {
          sizeType = "small";
        } else if (item.kichCo == "M") {
          sizeType = "medium";
        } else if (item.kichCo == "L") {
          sizeType = "large";
        }
        //set card
        var vCard = $("<div>", {
          class: "col-sm-4",
        }).appendTo(vRowComboPizza);
        //card header
        $("<div>", {
          html: `<h3>${item.kichCo} ( ${sizeType} size)</h3`,
          class: "card-header bg-main-brand text-white text-center",
        }).appendTo(vCard);
        //card body
        var vCardBody = $("<div>", {
          class: "card-body text-center",
        }).appendTo(vCard);
        //inside card body
        //ul
        var vUl = $("<ul>", {
          class: "list-group list-group-flush",
        }).appendTo(vCardBody);
        //li
        $("<li>", {
          html: `Đường kính <b>${item.duongKinh}</b>`,
          class: "list-group-item",
        }).appendTo(vUl);
        $("<li>", {
          html: `Sườn nướng <b>${item.suonNuong}</b>`,
          class: "list-group-item",
        }).appendTo(vUl);
        $("<li>", {
          html: `Salad <b>${item.salad}</b>`,
          class: "list-group-item",
        }).appendTo(vUl);
        $("<li>", {
          html: `Nước ngọt <b>${item.nuocNgot}</b>`,
          class: "list-group-item",
        }).appendTo(vUl);
        $("<li>", {
          html: `<h1>VND <b>${item.thanhTien}</b></h1>`,
          class: "list-group-item",
        }).appendTo(vUl);
        //card footer
        var vCardFooter = $("<div>", {
          class: "card-footer text-center",
        }).appendTo(vCard);
        $("<button>", {
          html: "Chọn",
          class: "btn-green",
          id: `btn-size-${sizeType}`,
        })
          .data("is-selected", "N")
          .appendTo(vCardFooter);
      });
      //gán sự kiện cho nút chọn combo pizza
      $("#btn-size-small").on("click", function () {
        onBtnSmallSizeClick();
      });
      $("#btn-size-medium").on("click", function () {
        onBtnMediumSizeClick();
      });
      $("#btn-size-large").on("click", function () {
        onBtnLargeSizeClick();
      });
    }
    //hàm get pizza
    function getPizza() {
      "use strict";
      const vBASE_URL = "https://647406377de100807b1a4df4.mockapi.io/types";
      $.ajax({
        url: vBASE_URL,
        type: "GET",
        dataType: "json",
        success: function (res) {
          // console.log(res);
          //gọi hàm load pizza
          loadPizza(res);
        },
        error: function (err) {
          console.log(err.message);
        },
      });
    }
    //hàm get combo pizza
    function getComboPizza() {
      "use strict";
      const vBASE_URL = "https://647406377de100807b1a4df4.mockapi.io/combos";
      $.ajax({
        url: vBASE_URL,
        type: "GET",
        dataType: "json",
        success: function (res) {
          // console.log(res);
          //gọi hàm load combo pizza
          loadComboPizza(res);
        },
        error: function (err) {
          console.log(err.message);
        },
      });
    }

    //mã nguồn để load data drink list (danh sách loại nước uống) về
    function getAllDrinks() {
      "use strict";
      var vBASE_URL = gBASE_URL + "/drinks";
      $.ajax({
        url: vBASE_URL,
        type: "GET",
        dataType: "json",
        success: function (res) {
          //truy xuất select drink qua id
          var vDrinkSelect = $("#select-drinks");
          //add options for student select
          res.forEach((element) => {
            //create new option
            $("<option>", {
              value: element.maNuocUong,
              html: element.tenNuocUong,
            }).appendTo(vDrinkSelect);
          });
        },
        error: function (err) {
          console.log(err.message);
        },
      });
    }
    //get response create
    function hanlderCreateResponse(paramRequest) {
      "use strict";
      var vResponse = JSON.parse(paramRequest.responseText);
      console.log(vResponse);
      if (vResponse) {
        //truy xuất vùng hiện thị thông tin
        var vThongBaoDiv = $("#div-container-order");
        var vThongBaoArea = $("#div-order-infor");
        //đổi thuộc tính class
        vThongBaoDiv.addClass("container bg-warning p-2 jumbotron");
        vThongBaoArea.addClass("text-dark p-3");
        vThongBaoArea.html(`Cảm ơn bạn đã đặt hàng tại Pizza 365. Mã đơn hàng của bạn là:<br />
                                           Mã đơn hàng:
                                           <span class="border border-dark w-300">${vResponse.orderCode}</span>`);
      }
    }

    //hàm request server tạo đơn hàng
    function createOrder(paramRequest, paramObject) {
      "use strict";
      //create url
      var vUrl = gBASE_URL + "/orders";
      //open request
      paramRequest.open("POST", vUrl, true);
      //set header
      paramRequest.setRequestHeader(
        "Content-Type",
        "application/json;charset=UTF-8"
      );
      //send request
      paramRequest.send(JSON.stringify(paramObject));
    }

    //hàm thu thập dữ liệu
    function getDataFormInput(paramObject) {
      "use strict";
      //truy xuất input thông qua id
      var vNameInput = $("#input-name");
      var vEmailInput = $("#input-email");
      var vPhoneInput = $("#input-phone");
      var vAddressInput = $("#input-address");
      var vMessageInput = $("#input-message");
      var vVoucherIdInput = $("#input-voucher");
      //truy xuất select thông qua id
      var vDrinkSelect = $("#select-drinks");
      //gán dữ liệu vào object
      paramObject.loaiNuocUong = vDrinkSelect.val();
      paramObject.hoVaTen = vNameInput.val().trim();
      paramObject.email = vEmailInput.val().trim();
      paramObject.dienThoai = vPhoneInput.val().trim();
      paramObject.diaChi = vAddressInput.val().trim();
      paramObject.loiNhan = vMessageInput.val().trim();
      paramObject.voucher = vVoucherIdInput.val().trim();
      paramObject.menuDuocChon = gSelectedCombo;
      paramObject.loaiPizza = gSelectedPizza;
    }
    //hàm kiểm tra kiểu dữ liệu
    function validateData(paramObject) {
      "use strict";
      //biến trả kết quả - mặc định true
      var vResult = true;
      var vMessage = ""; //nội dung alert thông báo
      //kiểm tra đã chọn menu
      if (!paramObject.menuDuocChon) {
        vMessage += "Bạn phải chọn loại kích cỡ pizza !\n";
        vResult = false;
      }
      //kiểm tra chọn pizza
      if (!paramObject.loaiPizza) {
        vMessage += "Bạn phải chọn một loại pizza !\n";
        vResult = false;
      }
      //kiểm tra chọn nước
      if (paramObject.loaiNuocUong == 0) {
        vMessage += "Bạn phải chọn một loại nước !\n";
        vResult = false;
      }
      //kiểm tra tên rỗng
      if (!paramObject.hoVaTen) {
        vMessage += "Bạn phải điền họ và tên !\n";
        vResult = false;
      }
      //kiểm tra địa chỉ
      if (!paramObject.diaChi) {
        vMessage += "Bạn phải điền địa chỉ !\n";
        vResult = false;
      }
      //kiểm tra email
      if (!paramObject.email) {
        vMessage += "Bạn phải điền email !\n";
        vResult = false;
      } else {
        if (!validateEmail(paramObject.email)) {
          vMessage += "Email không đúng định dạng !\n";
          vResult = false;
        }
      }
      //kiểm tra sdt
      if (!paramObject.dienThoai) {
        vMessage += "Bạn phải điền số thoại !\n";
        vResult = false;
      } else if (isNaN(paramObject.dienThoai)) {
        vMessage += "Điện thoại phải là số!\n";
        vResult = false;
      } else if (!validatePhone(paramObject.dienThoai)) {
        vMessage += "Điện thoại không đúng định dạng !\n";
        vResult = false;
      }

      if (vMessage) {
        alert(vMessage);
      }
      return vResult;
    }
    //hàm kiểm tra mã giảm giá ( voucherID )
    function getDiscountByVoucherID(paramVoucherID) {
      //% giảm giá - mặc định là 0%
      var vDiscount = 0;
      //create request
      var vBASE_URL =
        "http://203.171.20.210:8080/devcamp-pizza365/voucher_detail/";
      var vHttpRequest = new XMLHttpRequest();
      //open request
      var vAPI_URL = vBASE_URL + paramVoucherID;
      vHttpRequest.open("GET", vAPI_URL, false);
      //send request
      vHttpRequest.send();
      //get response
      if (vHttpRequest.status == gREQUEST_STATUS_OK) {
        var vResponse = JSON.parse(vHttpRequest.responseText);
        if (vResponse) {
          vDiscount = vResponse.phanTramGiamGia;
        }
      } else {
        alert("Mã giảm giá không tồn tại !!!");
      }
      return vDiscount;
    }
    //function trả lại một đối tượng package (gói đăng ký) được tham số hóa
    function getSizeComboObject(
      paramMenuCombo,
      paramDuongKinh,
      paramSuonNuong,
      paramSalad,
      paramDrink,
      paramPrice
    ) {
      var vComboObject = {
        //Đối tượng: menu (size combo)
        menuName: paramMenuCombo,
        duongKinhCM: paramDuongKinh,
        suonNuong: paramSuonNuong,
        saladGr: paramSalad,
        drink: paramDrink,
        priceVND: paramPrice,
        // method display plan infor - phương thức hiện thi gói đăng ký gym
        displayInConsoleLog() {
          console.log("COMBO SELECTED - loại size combo được chọn");
          //ghi thông tin combo ra console log
          console.log(this.menuName);
          console.log("Đường kính: " + this.duongKinhCM + "cm");
          console.log("Sườn nướng: " + this.suonNuong);
          console.log("Salad: " + this.saladGr + "gr");
          console.log("Nước ngọt: " + this.drink);
          console.log("Giá bán: " + "VND " + this.priceVND);
          console.log("============================");
        },
      };

      return vComboObject; //trả lại đối tượng, có đủ dữ liệu (attribute) và các methods (phương thức)
    }
    /* Hàm đổi màu button (Đăng ký) để phân biệt gói được chọn với các gói khác
        input: paramPackage có thể là "small", "medium", "large"
        hoạt động: ấn nút nào thì nút đó đổi màu vàng, 2 nút còn lại chuyển màu xanh
        và đánh dấu thuộc tính data-is-selected
        */
    function changeButtonColor(paramPackage) {
      //combo size
      var vBtnSmallSize = $("#btn-size-small"); // truy vấn nút small
      var vBtnMediumSize = $("#btn-size-medium"); //truy vấn nút medium
      var vBtnLargeSize = $("#btn-size-large"); //truy vấn nút large
      //pizza type
      var vBtnHawaiPizza = $("#btn-type-hawai"); // truy vấn nút pizza hawai
      var vBtnHaiSanPizza = $("#btn-type-seafood"); //truy vấn nút pizza hai san
      var vBtnBaconPizza = $("#btn-type-bacon"); //truy vấn nút pizza bacon
      //kiểm tra loại combo
      if (paramPackage === gSMALL_SIZE) {
        vBtnSmallSize.removeClass().addClass("btn-yellow");
        vBtnMediumSize.removeClass().addClass("btn-green");
        vBtnLargeSize.removeClass().addClass("btn-green");

        vBtnSmallSize.data("is-selected", "Y");
        vBtnMediumSize.data("is-selected", "N");
        vBtnLargeSize.data("is-selected", "N");
      } else if (paramPackage === gMEDIUM_SIZE) {
        vBtnSmallSize.removeClass().addClass("btn-green");
        vBtnMediumSize.removeClass().addClass("btn-yellow");
        vBtnLargeSize.removeClass().addClass("btn-green");

        vBtnSmallSize.data("is-selected", "N");
        vBtnMediumSize.data("is-selected", "Y");
        vBtnLargeSize.data("is-selected", "N");
      } else if (paramPackage === gLARGE_SIZE) {
        vBtnSmallSize.removeClass().addClass("btn-green");
        vBtnMediumSize.removeClass().addClass("btn-green");
        vBtnLargeSize.removeClass().addClass("btn-yellow");

        vBtnSmallSize.data("is-selected", "N");
        vBtnMediumSize.data("is-selected", "N");
        vBtnLargeSize.data("is-selected", "Y");
      }
      //kiêm tra loại pizza
      else if (paramPackage === gHAWAI_PIZZA) {
        vBtnHawaiPizza.removeClass().addClass("btn-yellow");
        vBtnHaiSanPizza.removeClass().addClass("btn-green");
        vBtnBaconPizza.removeClass().addClass("btn-green");

        vBtnHawaiPizza.data("is-selected", "Y");
        vBtnHaiSanPizza.data("is-selected", "N");
        vBtnBaconPizza.data("is-selected", "N");
      } else if (paramPackage === gHAI_SAN_PIZZA) {
        vBtnHawaiPizza.removeClass().addClass("btn-green");
        vBtnHaiSanPizza.removeClass().addClass("btn-yellow");
        vBtnBaconPizza.removeClass().addClass("btn-green");

        vBtnHawaiPizza.data("is-selected", "N");
        vBtnHaiSanPizza.data("is-selected", "Y");
        vBtnBaconPizza.data("is-selected", "N");
      } else if (paramPackage === gBACON_PIZZA) {
        vBtnHawaiPizza.removeClass().addClass("btn-green");
        vBtnHaiSanPizza.removeClass().addClass("btn-green");
        vBtnBaconPizza.removeClass().addClass("btn-yellow");

        vBtnHawaiPizza.data("is-selected", "N");
        vBtnHaiSanPizza.data("is-selected", "N");
        vBtnBaconPizza.data("is-selected", "Y");
      }
    }
    // hàm kiểm tra email đúng định dạng ko?
    function validateEmail(paramEmail) {
      var vValidRegex =
        /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|.(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
      if (paramEmail.match(vValidRegex)) {
        return true;
      } else {
        return false;
      }
    }
    // hàm kiểm tra số điện thoại đúng định dạng ko?
    function validatePhone(paramPhone) {
      var vValidRegex = /((0|\+)+([0-9]{9,11})\b)/g;
      if (paramPhone.match(vValidRegex)) {
        return true;
      } else {
        return false;
      }
    }
  </script>
</html>
